stages:
  - build
  - release

build:
  stage: build
  image: golang:1.21
  script:
    - cd src/app
    - go mod tidy
    - go build -o main

release:
  stage: release
  image: docker:latest
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
  script:
    - 'docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME .'
    - 'docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY'
    - 'docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME'
  only:
    - develop
    - main
